--- a/makedefs
+++ b/makedefs
@@ -215,7 +215,7 @@ error() {
 
 case $# in
  # Officially supported usage.
- 0) SYSTEM=`(uname -s) 2>/dev/null`
+ 0) SYSTEM="OpenWRT"
     RELEASE=`(uname -r) 2>/dev/null`
     # No ${x%%y} support in Solaris 11 /bin/sh
     RELEASE_MAJOR=`expr "$RELEASE" : '\([0-9]*\)'` || exit 1
@@ -242,6 +242,15 @@ case "$SYSTEM" in
 esac
 
 case "$SYSTEM.$RELEASE" in
+   OpenWRT*)    SYSTYPE=LINUX$RELEASE_MAJOR
+		SYSLIBS="$SYSLIBS -ldl"
+		: ${SHLIB_SUFFIX=.so}
+		: ${SHLIB_CFLAGS=-fPIC}
+		: ${SHLIB_LD="${CC-gcc} -shared"' -Wl,-soname,${LIB}'}
+		: ${SHLIB_RPATH='-Wl,--enable-new-dtags -Wl,-rpath,${SHLIB_DIR}'}
+		: ${SHLIB_ENV="LD_LIBRARY_PATH=`pwd`/lib"}
+		: ${PLUGIN_LD="${CC-gcc} -shared"}
+		;;
    SCO_SV.3.2)	SYSTYPE=SCO5
 		# Use the native compiler by default
 		: ${CC="/usr/bin/cc -b elf"}
